var api = require("../../utils/api.js");
import { API_SCAN } from '../../const/apiurl'
Page({
  data: {
    //是否正在用券
    couponUseing:false,
    //0代表弹窗关闭 1代表手动输入条码弹窗 2代表会员 3.收款 4.退款 
    scene: 0,
    //总数量
    totalNum: 0,
    //应付款
    payPrice: "0.00",
    goods: [
    ]
  },
  onLoad() { },

  //键盘完成
  onKeyBordFinished(data) {
    let mockdata = '{"activityId": "5808753370","activityType": "Skus","activityName": "2020年新活动，中国加油","discnt": 100,"startTime": 1580877000000,"endTime": 1583423999000,"pic": "https://miya-ngm.oss-cn-hangzhou.aliyuncs.com/1560763177031148973127.png?Expires=1876123177&OSSAccessKeyId=LTAItcMpilplOYdV&Signature=9NTSNuDocXKQyr%2FbPlHooey3Vrg%3D","name": "test001","barcode": "09876","price": 100000,"salePrice": 100000,"hasDiscount": true}';

    this.parseGoodInfo(JSON.parse(mockdata))

    this.onKeyBordClose();
  },

  //  键盘关闭
  onKeyBordClose() {
    this.setData({ scene: 0 })
  },

  // 手动输入码
  manualBarcode(e) {
    this.setData({ scene: 1 })
  },

  //清空商品信息
  clearGood(e) {
    this.setData({ goods: [] })
  },

  //转化商品信息
  parseGoodInfo(goodinfo) {

    //价格 分转元
    goodinfo.quantity = 1;
    goodinfo.price = goodinfo.price / 100
    goodinfo.salePrice = goodinfo.salePrice / 100
    goodinfo.discnt = goodinfo.discnt / 100

    //总数量
    let totalQuantityTemp = 0
    //总价格
    let totalPriceTemp = 0.00

    //数量+1 
    let isHasSame = false;
    let lastgoods = this.data.goods;
    let goodstemp = []
    let goodtemp
    lastgoods.forEach(function (item, index, array) {
      if (item.barcode == goodinfo.barcode) {
        let quantitytemp = item.quantity
        item.quantity = quantitytemp + 1
        isHasSame = true
        goodtemp = item
      } else {
        totalQuantityTemp = totalQuantityTemp + item.quantity
        totalPriceTemp = totalPriceTemp + item.price * item.quantity
        goodstemp.push(item)
      }

    })
    if (isHasSame) {
      totalQuantityTemp = totalQuantityTemp + goodtemp.quantity
      totalPriceTemp = totalPriceTemp + goodtemp.price * goodtemp.quantity

      let nowgoods = []
      nowgoods.push(goodtemp);
      var newgoods = nowgoods.concat(goodstemp)
      this.setData({ goods: newgoods })
    } else {
      totalQuantityTemp = totalQuantityTemp + 1
      totalPriceTemp = totalPriceTemp + goodinfo.price
      let nowgoods = []
      nowgoods.push(goodinfo);
      var newgoods = nowgoods.concat(lastgoods)
      this.setData({ goods: newgoods })
    }

    //汇总
    this.setData({
      totalNum: totalQuantityTemp,
      payPrice: totalPriceTemp,
    })

  },

  //删除商品
  deleteGood(e) {

  

    let barcode = e.target.id;
    let lastgoods = this.data.goods;
    let newGoods = []
    lastgoods.forEach(function (item, index, array) {
      if (barcode != item.barcode) {
        newGoods.push(item);
      }
    })
    this.setData({ goods: newGoods })

  },
  //减少商品
  decreaseGood(e) {

    let barcode = e.target.id;
    let lastgoods = this.data.goods;
    let newGoods = []
    lastgoods.forEach(function (item, index, array) {
      if (barcode == item.barcode) {
        if (item.quantity != 1) {
          let quantitytemp = item.quantity
          item.quantity = quantitytemp - 1
          newGoods.push(item);

        }
      } else {
        newGoods.push(item);
      }
    })
    this.setData({ goods: newGoods })

  },
  //增加商品
  increaseGood(e) {

    console.log(e);

    let barcode = e.target.id;
    let lastgoods = this.data.goods;
    let newGoods = []
    lastgoods.forEach(function (item, index, array) {
      if (barcode == item.barcode) {
        let quantitytemp = item.quantity
        item.quantity = quantitytemp + 1
        newGoods.push(item);
      } else {
        newGoods.push(item);
      }
    })
    this.setData({ goods: newGoods })


  },
  //用券返回
  couponBack(e){
         this.setData({ couponUseing: false })
  },
  //使用券
  useCoupon(e){
       this.setData({ couponUseing: true })
  }






});
